//
//  tweakDemo5.mm
//  tweakDemo5
//
//  Created by xxx on 16/4/7.
//  Copyright (c) 2016年 __MyCompanyName__. All rights reserved.
//

// CaptainHook by Ryan Petrich
// see https://github.com/rpetrich/CaptainHook/

#import <Foundation/Foundation.h>
#import "CaptainHook/CaptainHook.h"
#include <notify.h> // not required; for examples only
#import <UIKit/UIKit.h>


// Objective-C runtime hooking using CaptainHook:
//   1. declare class using CHDeclareClass()
//   2. load class using CHLoadClass() or CHLoadLateClass() in CHConstructor
//   3. hook method using CHOptimizedMethod()
//   4. register hook using CHHook() in CHConstructor
//   5. (optionally) call old method using CHSuper()


@interface tweakDemo5 : NSObject

@end

@implementation tweakDemo5

-(id)init
{
	if ((self = [super init]))
	{
	}

    return self;
}

@end


@class SpringBoard;

CHDeclareClass(SpringBoard); // declare class


CHOptimizedMethod(1, self, void, SpringBoard, applicationDidFinishLaunching, id, application) // hook method (with 2 arguments and a return value)
{
	// write code here ...

	CHSuper(1, SpringBoard, applicationDidFinishLaunching, application); // call old (original) method and return its return value
    UIAlertView *alert = [[UIAlertView alloc]initWithTitle:@"11" message:@"22" delegate:nil cancelButtonTitle:@"222" otherButtonTitles:@"www", nil];
    [alert show];
    [alert release];
    
}

static void WillEnterForeground(CFNotificationCenterRef center, void *observer, CFStringRef name, const void *object, CFDictionaryRef userInfo)
{
	// not required; for example only
}

static void ExternallyPostedNotification(CFNotificationCenterRef center, void *observer, CFStringRef name, const void *object, CFDictionaryRef userInfo)
{
	// not required; for example only
}

CHConstructor // code block that runs immediately upon load
{
	@autoreleasepool
	{
		// listen for local notification (not required; for example only)
		CFNotificationCenterRef center = CFNotificationCenterGetLocalCenter();
		CFNotificationCenterAddObserver(center, NULL, WillEnterForeground, CFSTR("UIApplicationWillEnterForegroundNotification"), NULL, CFNotificationSuspensionBehaviorCoalesce);
		
		// listen for system-side notification (not required; for example only)
		// this would be posted using: notify_post("com.fuckcode.tweakDemo5.tweakDemo5.eventname");
		CFNotificationCenterRef darwin = CFNotificationCenterGetDarwinNotifyCenter();
		CFNotificationCenterAddObserver(darwin, NULL, ExternallyPostedNotification, CFSTR("com.fuckcode.tweakDemo5.tweakDemo5.eventname"), NULL, CFNotificationSuspensionBehaviorCoalesce);
		
		// CHLoadClass(SpringBoard); // load class (that is "available now")
		// CHLoadLateClass(SpringBoard);  // load class (that will be "available later")
		
//		CHHook(0, SpringBoard, messageName); // register hook
//		CHHook(2, SpringBoard, arg1, arg2); // register hook
        CHLoadLateClass(SpringBoard);
        CHHook(1, SpringBoard, applicationDidFinishLaunching); // register hook
        
	}
}
